<?php
/**
 * Обработка POST-запросов
 * 
 * @package    Dashamail integration
 * @author     dashamail.ru
 * @version    1.0
 * @license    http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2017 http://dashamail.ru
 */

if (! defined('DIAFAN'))
{
	include dirname(dirname(dirname(__FILE__))).'/includes/404.php';
}

class Dashamail_admin_action extends Action_admin
{
	/**
	 * Вызывает обработку Ajax-запросов
	 * 
	 * @return void
	 */
	public function init()
	{
		Custom::inc('modules/dashamail/admin/dashamail.admin.inc.php');
		$this->expf = new Dashamail_admin_inc($this->diafan);
			
		if (! empty($_POST["action"]))
		{
			switch($_POST["action"])
			{
				case 'importusers':
					$this->importUsers();
					break;
				case 'saveform':
					$this->saveForm();
					break;
				case 'changefields':
					$this->changeFields();
					break;
			}
		}
	}

	/**
	 * Вызывает обработку Ajax-запросов
	 * 
	 * @return void
	 */
	public function importUsers()
	{
		if(isset($_POST['user_group']) && isset($_POST['list_id']) && $_POST['user_group'] && $_POST['list_id']) {
			$access = DB::query_fetch_all("SELECT * FROM {dasha_settings} LIMIT 1");
			if ($access) {
				$check = DB::query_fetch_all("SELECT id FROM {dasha_export} WHERE user_type=".intval($_POST['user_group'])." AND list_id=".intval($_POST['list_id'])." LIMIT 1");
				if ($check) {
					//DB::query("UPDATE {dasha_settings} SET username='".$_POST['dasha_user']."', password='".$_POST['dasha_pass']."' WHERE id=".$check[0]['id']);
				} else {
					DB::query("INSERT INTO {dasha_export} (user_type, list_id) VALUES (".intval($_POST['user_group']).", ".intval($_POST['list_id']).")");
				}
				$importResult = $this->expf->importContacts($access[0]['username'], $access[0]['password'], intval($_POST['user_group']), intval($_POST['list_id']));
				if ($importResult) {
					DB::query("UPDATE {dasha_export} SET imported=imported+".$importResult." WHERE list_id=".intval($_POST['list_id']));
				}
				$this->result["name"] = 'Импортировано '.$importResult.' контактов';
			}
		} else {
			$this->result["name"] = 'Ошибка';
		}
	}
	
	public function saveForm()
	{
		if(isset($_POST['list_id']) && $_POST['list_id']) {
			$check = DB::query_fetch_all("SELECT id FROM {dasha_form} LIMIT 1");
			if ($check) {
				DB::query("UPDATE {dasha_form} SET list_id=".intval($_POST['list_id']).", merges='".$_POST['merges']."', title='".htmlentities(strip_tags($_POST['formtitle']), ENT_QUOTES, "UTF-8")."' WHERE id=".$check[0]['id']);
			} else {
				DB::query("INSERT INTO {dasha_form} (list_id, merges, title) VALUES (".intval($_POST['list_id']).", '".$_POST['merges']."', '".htmlentities(strip_tags($_POST['formtitle']), ENT_QUOTES, "UTF-8")."')");
			}
			$this->result["name"] = 'Сохранено';
		} else {
			$this->result["name"] = 'Ошибка';
		}
	}
	
	public function changeFields()
	{
		if(isset($_POST['list_id']) && $_POST['list_id']) {
			$access = DB::query_fetch_all("SELECT * FROM {dasha_settings} LIMIT 1");
			if ($access) {
				$fieldlist = '';
				$fields = $this->expf->getFields($access[0]['username'], $access[0]['password'], intval($_POST['list_id']));
				if ($fields) {
					foreach ($fields as $i=>$field) {
						if ($field) {
							if (is_array($field['title'])) {
								$title = $field['title']['name'];
							} else {
								$title = $field['title'];
							}
							$fieldlist .= '<p style="margin: 10px 0;"><input type="checkbox" class="fieldlist" name="fl-'.($i+1).'" id="fl-'.($i+1).'" value="'.($i+1).'" style="width: 25px; position: relative; top: 2px;">'.$title.'</p>';
						}
					}
				}
				$this->result["name"] = $fieldlist;
			} else {
				$this->result["name"] = 'Ошибка';
			}
		} else {
			$this->result["name"] = 'Ошибка';
		}	
	}
}
