<?php
/**
 * @package    Dashamail integration
 * @author     dashamail.ru
 * @version    1.0
 * @license    http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2017 http://dashamail.ru
 */
if (!defined('DIAFAN'))
{
    include dirname(dirname(dirname(__FILE__))).'/includes/404.php';
}

/**
 * Example_admin_inc
 */
class Dashamail_admin_inc extends Diafan
{
	
	public static function query($method, $login, $password, $params = array())
	{
		$POST = array (
          'username' => $login,
		  'password' => $password,
        );
        if (!$POST) {$POST = array();}
        $POST = array_merge((array)$params, $POST);
        
		$ContextOptions = array(
			'http' =>
				array(
					'method'  => 'POST',
					'header'  => 'Content-type: application/x-www-form-urlencoded; charset=utf-8;',
					'content' => http_build_query($POST)
				)
		);

		$Context = stream_context_create($ContextOptions);

		$result = file_get_contents('http://api.dashamail.com/?method='.$method.'&format=json', FALSE, $Context);
		//print_r($result);
		return $result;
	}
	
	private function checkErrors($jsonResult)
    {
        if ($jsonResult->response->msg->err_code != 0)
        {
            $error = $jsonResult->response->msg->text;
            $code = $jsonResult->response->msg->err_code;

            $this->error = array($error, $code);
            return false;
        }
        else
            return true;
    }
	
	public function getLists($login, $password)
	{
		if (($json = $this->query("lists.get", $login, $password))!==false)
		{
			$data_c = json_decode($json);
			// если есть ошибки
			if ($this->checkErrors($data_c)===true)
			{
				$data = json_decode($json, true);
				$lists = array();
				foreach ($data['response']['data'] as $res)
				{
					$list_id = intval($res['id']);
					$list_title = trim($res['name']);
					for ($i = 1; $i<6; $i++) {
						$f = unserialize($res['merge_'.$i]);
						if ($f['type'] == 'text') {
						$arrf[$i] = $f['title'];
						};
					};
					
					$lists[] = array('id'=>$list_id, 'title'=>$list_title, 'fields'=>$arrf);
				}
				return $lists;
			}
			else
				return false;
		}
		else {
			echo '<p style="color:#ff0000;">Api временно недоступно. Попробуйте позже.</p>';
			return false;
		}
	}
	
	public function getFields($login, $password, $list_id)
    {
        if (($json = $this->query("lists.get", $login, $password, array('list_id'=>$list_id)))!==false)
        {
            $data_c = json_decode($json);
            // если есть ошибки
            if ($this->checkErrors($data_c)===true)
            {
                $data = json_decode($json, true);
                $fields = array();
                foreach ($data['response']['data'] as $res)
                {
					for ($i=1; $i<11; $i++) {
						if (isset($res['merge_'.$i])) {
							$fields[] = unserialize($res['merge_'.$i]);
						}
						
					}
                }
                //print_r($fields);
                return $fields;
            }
            else
                return false;
        }
        else
            return false;
    }
	
	public function importContacts($login, $password, $user_group, $list_id)
	{
		$total = 0;
		$users = DB::query_fetch_all("SELECT * FROM {users} WHERE role_id=".$user_group);
		foreach ($users as $user) {
			$user_arr = array('email'=>$user['mail'], 'merge_1'=>$user['fio'], 'list_id'=>$list_id);
			if (($json = $this->query("lists.add_member", $login, $password, $user_arr))!==false)
			{
				$data = json_decode($json);
				// если есть ошибки
				if ($this->checkErrors($data)===true)
				{
					//$results = array();
					//print_r($data);
					//die();
					if (isset($data->response->data->member_id)) {
						$total = $total + 1;
					}
				}
			}
		}
		return $total;
	}
}
