<?php
/**
 * Установка модуля
 *
 * @package    Dashamail integration
 * @author     dashamail.ru
 * @version    1.0
 * @license    http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2017 http://dashamail.ru
 */

if (! defined('DIAFAN'))
{
    include dirname(dirname(dirname(__FILE__))).'/includes/404.php';
}

class Dashamail_install extends Install
{
    /**
     * @var string название
     */
    public $title = "Интеграция с Dashamail";

    /**
     * @var array таблицы в базе данных
     */
    public $tables = array(
		array(
			"name" => "dasha_export",
			"fields" => array(
				array(
                "name" => "id",
                "type" => "INT(11) UNSIGNED NOT NULL AUTO_INCREMENT",
				),
				array(
					"name" => "user_type",
					"type" => "TINYINT(1) UNSIGNED NOT NULL DEFAULT '1'",
				),
				array(
					"name" => "list_id",
					"type" => "INT(11) UNSIGNED NOT NULL DEFAULT '0'",
				),
				array(
					"name" => "imported",
					"type" => "INT(11) UNSIGNED NOT NULL DEFAULT '0'",
				),
			),
			"keys" => array(
				"PRIMARY KEY (id)",
			),
		),
		array(
			"name" => "dasha_settings",
			"fields" => array(
				array(
                "name" => "id",
                "type" => "INT(11) UNSIGNED NOT NULL AUTO_INCREMENT",
				),
				array(
					"name" => "username",
					"type" => "VARCHAR(255) DEFAULT ''",
				),
				array(
					"name" => "password",
					"type" => "VARCHAR(255) DEFAULT ''",
				),
			),
			"keys" => array(
				"PRIMARY KEY (id)",
			),
		),
		array(
			"name" => "dasha_form",
			"fields" => array(
				array(
                "name" => "id",
                "type" => "INT(11) UNSIGNED NOT NULL AUTO_INCREMENT",
				),
				array(
					"name" => "list_id",
					"type" => "INT(11) UNSIGNED NOT NULL DEFAULT '0'",
				),
				array(
					"name" => "merges",
					"type" => "VARCHAR(255) DEFAULT ''",
				),
				array(
					"name" => "title",
					"type" => "VARCHAR(255) DEFAULT ''",
				),
			),
			"keys" => array(
				"PRIMARY KEY (id)",
			),
		),
	);

    /**
     * @var array записи в таблице {modules}
     */
    public $modules = array(
        array(
            "name" => "dashamail",
            "admin" => true,
            "site" => true,
            "site_page" => true,
        ),
    );

    /**
     * @var array меню административной части
     */
    public $admin = array(
        array(
            "name" => "Интеграция с Dashamail",
            "rewrite" => "dashamail",
            "group_id" => "1",
            "sort" => 5,
            "act" => true,
            "children" => array(
                array(
                    "name" => "Настройки",
                    "rewrite" => "dashamail/config",
                ),
            )
        ),
    );
}
